import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class ButtonGo extends Applet
  implements ActionListener, 
  MouseMotionListener, MouseListener
{
  Button btn;
  int btnX = 0;
  int btnY = 0;
  Dimension dm;
  boolean bYellow = false;

  // ============================================
  // init
  // ============================================
  public void init()
  {
    btn = new Button("Yellow");
    setLayout(null);
    
    add(btn);
    btn.addActionListener(this);
    
    this.addMouseMotionListener(this);
    this.addMouseListener(this);
    
    dm = getSize();
    
    btnX = dm.width / 2;
    btnY = dm.height / 2;
  }
  
  // ============================================
  // paint
  // ============================================
  public void paint(Graphics g)
  {
    btn.setBounds(btnX, btnY, 70, 25);
  }
  
  // ============================================
  // actionPerformed
  // ============================================
  public void actionPerformed(ActionEvent e)
  {
    if(e.getSource().equals(btn))
    {
      if(!bYellow)      
      {
        setBackground(Color.yellow);
	bYellow = true;
	btn.setLabel("White");
      }
      else
      {
        setBackground(Color.white);
	bYellow = false;
	btn.setLabel("Yellow");
      }
    }
  }
  
  // ============================================
  // getAppletInfo
  // ============================================
  public String getAppletInfo()
  {
    return "Name: ButtonGo";
  }
  
  // ============================================
  // mouseMoved
  // ============================================
  public void mouseMoved(MouseEvent e)
  {
    btnX = e.getX() - 30;
    btnY = e.getY() - 12;
    
    repaint();
  }
  
  // ============================================
  // mouseDragged
  // ============================================
  public void mouseDragged(MouseEvent e)
  {
  }
  
  // ============================================
  // mousePressed
  // ============================================
  public void mousePressed(MouseEvent e)
  {
  }

  // ============================================
  // mouseReleased
  // ============================================
  public void mouseReleased(MouseEvent e)
  {
  }
  
  // ============================================
  // mouseClicked
  // ============================================
  public void mouseClicked(MouseEvent e)
  {
  }
  
  // ============================================
  // mouseEntered
  // ============================================
  public void mouseEntered(MouseEvent e)
  {
  }
  
  // ============================================
  // mouseExited
  // ============================================
  public void mouseExited(MouseEvent e)
  {
  }
}
